##
##  consul.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_consul_opkg 1.22.0
%define       V_consul_base 1.22.0
%define       V_consul_snap 20251002

#   package information
Name:         consul
Summary:      Service Discovery, Monitoring, Configuration and Connectivity
URL:          http://www.consul.io/
Vendor:       Armon Dadgar, Mitchell Hashimoto
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Networking
License:      MPL
Version:      %{V_consul_opkg}.%{V_consul_snap}
Release:      20251002

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/consul/consul-%{V_consul_snap}.tar.xz
Source1:      rc.consul
Source2:      consul.hcl
Source3:      consul-openpkg-service.sh
Source4:      consul-openpkg-service.c
Source5:      consul-acl-update.sh
Source6:      consul-acl.txt

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, uuid, go
PreReq:       OpenPKG, openpkg >= 20160101, uuid, jq, curl, sed

%description
    Consul is a tool for service discovery, monitoring, configuration
    and connectivity in a cluster of machines. Consul is distributed,
    highly available, and extremely scalable. Consul provides several
    key features: Service Discovery (via REST or DNS interfaces), Health
    Checking, Key/Value Storage and Multi-Datacenter Support. It is
    internally based on the excellent RAFT consensus protocol and the
    SWIM gossip/membership protocol.

%track
    prog consul:release = {
        version   = %{V_consul_base}
        url       = https://github.com/hashicorp/consul/releases
        regex     = tree/v(\d+\.\d+\.\d+)
    }
    prog consul:snapshot = {
        version   = %{V_consul_snap}
        url       = http://download.openpkg.org/components/versioned/consul/
        regex     = consul-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n consul

%build
    #   build program
    export GOPATH=`pwd`
    (   cd src/github.com/hashicorp/consul
        go build \
            -v \
            -tags="consul" \
            -ldflags "-X github.com/hashicorp/consul/version.GitCommit='%{V_consul_snap}'" \
            -o bin/consul
    ) || exit $?

    #   build helper program
    %{l_shtool} install -c %{l_value -s -a} \
        %{SOURCE consul-openpkg-service.c} .
    %{l_cc} %{l_cflags -O} %{l_ldflags} \
        -o consul-openpkg-service \
        consul-openpkg-service.c

%install
    #   create directory hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/sbin \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/consul \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d \
        $RPM_BUILD_ROOT%{l_prefix}/etc/consul/acl.d \
        $RPM_BUILD_ROOT%{l_prefix}/var/consul/log \
        $RPM_BUILD_ROOT%{l_prefix}/var/consul/run \
        $RPM_BUILD_ROOT%{l_prefix}/var/consul/data

    #   install program
    %{l_shtool} install -c -s -m 755 \
        src/github.com/hashicorp/consul/bin/consul \
        $RPM_BUILD_ROOT%{l_prefix}/sbin/consul
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE consul-acl-update.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/sbin/consul-acl-update

    #   install configuration files
    key=`src/github.com/hashicorp/consul/bin/consul keygen`
    token=`uuid -v4`
    %{l_shtool} install -c -m 644 %{l_value -s -a} \
        -e "s;@key@;$key;g" \
        -e "s;@token@;$token;g" \
        %{SOURCE consul.hcl} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/consul/

    #   install client ACL management
    for name in `grep "^<file" %{SOURCE consul-acl.txt} | sed -e 's;^.*name=";;' -e 's;".*$;;'`; do
        name_escaped=`echo "$name" | sed -e 's;/;\\\\/;g'`
        (echo ""; cat %{SOURCE consul-acl.txt}; echo "") |\
            sed -e "1,/^<file name=\"$name_escaped\">/d" -e "/<\/file>/,\$d" >tmp.txt
        %{l_shtool} install -c -m 644 %{l_value -s -a} \
            tmp.txt $RPM_BUILD_ROOT%{l_prefix}/etc/consul/acl.d/$name
    done

    #   install utility script
    %{l_shtool} install -c -m 755 \
        consul-openpkg-service \
        $RPM_BUILD_ROOT%{l_prefix}/sbin/
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE consul-openpkg-service.sh} \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/consul/

    #   install run-command script
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        %{SOURCE rc.consul} $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%config %{l_prefix}/etc/consul/*' \
        '%config %{l_prefix}/etc/consul/*/*' \
        '%attr(4755,%{l_susr},%{l_mgrp}) %{l_prefix}/sbin/consul-openpkg-service' \
        '%attr(-,%{l_rusr},%{l_rgrp}) %{l_prefix}/var/consul/*'

%files -f files

%clean

%post
    #   after upgrade, restart service
    [ $1 -eq 2 ] || exit 0
    eval `%{l_rc} consul status 2>/dev/null`
    [ ".$consul_active" = .yes ] && %{l_rc} consul restart
    exit 0

%preun
    #   before erase, stop service and remove log files
    [ $1 -eq 0 ] || exit 0
    %{l_rc} consul stop 2>/dev/null
    rm -rf $RPM_INSTALL_PREFIX/var/consul/log/*  >/dev/null 2>&1 || true
    rm -rf $RPM_INSTALL_PREFIX/var/consul/run/*  >/dev/null 2>&1 || true
    rm -rf $RPM_INSTALL_PREFIX/var/consul/data/* >/dev/null 2>&1 || true
    exit 0

